﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'v1.00
Sub Class_Globals
	Public Shared_Folder As String
	Public Use_File_Provider As Boolean
	Private rp As RuntimePermissions
End Sub

Public Sub Initialize
	Dim Ph_one As Phone
	If Ph_one.SdkVersion >= 24 Or File.ExternalWritable = False Then
		Use_File_Provider = True
		Shared_Folder = File.Combine(File.DirInternal, "shared")
		File.MakeDir("", Shared_Folder)
	Else
		Use_File_Provider = False
		Shared_Folder = rp.GetSafeDirDefaultExternal("shared")
	End If
'	Log("Using FileProvider? " & Use_File_Provider)
End Sub

'Returns the file uri.
Public Sub GetFileuri (File_Name As String) As Object
	If Use_File_Provider = False Then
		Dim Uniform_Resource_Identifier As JavaObject
		Return Uniform_Resource_Identifier.InitializeStatic("android.net.Uri").RunMethod("parse", Array("file://" & File.Combine(Shared_Folder, File_Name)))
	Else
		Dim f As JavaObject
		f.InitializeNewInstance("java.io.File", Array(Shared_Folder, File_Name))
		Dim fp As JavaObject
		Dim context As JavaObject
		context.InitializeContext
		fp.InitializeStatic("android.support.v4.content.FileProvider")
		Return fp.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
	End If
End Sub

'Replaces the intent Data field with the file uri.
'Resets the type field. Make sure to call Intent.SetType after calling this method
Public Sub SetFileUriAsIntentData (In_tent As Intent, File_Name As String)
	Dim jo As JavaObject = In_tent
	jo.RunMethod("setData", Array(GetFileuri(File_Name)))
	In_tent.Flags = Bit.Or(In_tent.Flags, 1) 'FLAG_GRANT_READ_URI_PERMISSION
End Sub